// =========================================================
// Разбор входного потока при помощи класса 
// StreamTokenizer 
//
// (C) Фролов А.В, 1997
//
// E-mail: frolov@glas.apc.org
// WWW:    http://www.glasnet.ru/~frolov
//            или
//         http://www.dials.ccas.ru/frolov
// =========================================================
import java.io.*;

// =========================================================
// Класс StreamToken
// Главный класс приложения
// =========================================================
public class StreamToken
{
  // -------------------------------------------------------
  // main
  // Метод, получающий управление при запуске приложения
  // -------------------------------------------------------
  public static void main(String args[])
  {
    // Выходной поток
    DataOutputStream OutStream;

    // Входной поток
    DataInputStream  InStream;

    // Массив для ввода строки с клавиатуры
    byte bKbdInput[] = new byte[256];

    // Введенная строка, которая будет записана в поток
    String sOut;

    try
    {
      // Выводим строку приглашения
      System.out.println("Enter string to parse...");
      
      // Читаем с клавиатуры строку для записи в файл
      System.in.read(bKbdInput);

      // Преобразуем введенные символы в строку типа String
      sOut = new String(bKbdInput, 0);
    
      // Создаем выходной буферизованный поток данных
      OutStream = new DataOutputStream(
        new BufferedOutputStream(
          new FileOutputStream("output.txt")));

      // Записываем строку sOut в выходной поток
      OutStream.writeBytes(sOut);

      // Закрываем выходной поток
      OutStream.close();

      // Создаем входной буферизованный поток данных
      InStream = new DataInputStream(
        new BufferedInputStream(
          new FileInputStream("output.txt")));

      // Создаем объект для разбора потока
      TokenizerOfStream tos = new TokenizerOfStream();

      // Выполняем разбор
      tos.TokenizeIt(InStream);

      // Закрываем входной поток
      InStream.close();

      System.out.println("Press <Enter> to terminate...");
      System.in.read(bKbdInput);
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}

// =========================================================
// Класс TokenizerOfStream
// Класс для разбора входного потока
// =========================================================
class TokenizerOfStream
{
  public void TokenizeIt(InputStream is)
  {
    // Создаем разборщик потока
    StreamTokenizer stok;

    // Временная строка
    String str;

    try
    {
      // Создаем разборщик потока
      stok = new StreamTokenizer(is);

      // Задаем режим исключения комментариев,
      // записанных в стиле С++ (два символа '/')
      stok.slashSlashComments(true);

      // Указываем , что символ '.' будет обычным символом
      stok.ordinaryChar('.');

      // Запускаем цикл разбора потока,
      // который будет завершен при достижении
      // конца потока
      while(stok.nextToken() != StreamTokenizer.TT_EOF)
      {
        // Определяем тип выделенного элемента
        switch(stok.ttype)
        {
          // Если это слово, записываем его во
          // временную строку
          case StreamTokenizer.TT_WORD:
          {
            str = new String("\nTT_WORD >" + stok.sval);
            break;
          }

          // Если это число, преобразуем его
          // в строку
          case StreamTokenizer.TT_NUMBER:
          {
            str = "\nTT_NUMBER >" + Double.toString(stok.nval);
            break;
          }

          // Если найден конец строки, 
          // выводим строку End of line
          case StreamTokenizer.TT_EOL:
          {
            str = new String("> End of line");
            break;
          }

          // Выводим прочие символы
          default:
            {
              if((char)stok.ttype == '"')
              {
                str = new String("\nTT_WORD >" + stok.sval);
              }

              else
                str = "> " + String.valueOf((char)stok.ttype);
            }
        }

        // Выводим на консоль содержимое временной строки
        System.out.println(str);
      }
    }
    catch(Exception ioe)
    {
      System.out.println(ioe.toString());
    }
  }
}